//@author: antokhio
//@help: template for standard shaders
//@tags: template
//@credits: 

StructuredBuffer<float4> color <bool color=true;>;

Texture2D tex0;
SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_LINEAR;AddressU=CLAMP;AddressV=CLAMP;};

float4x4 tW : WORLD;
float4x4 tVP : VIEWPROJECTION;

float Alpha <float uimin=0.0; float uimax=1.0;> = 1; 
float4 cAmb <bool color=true; String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };
float4x4 tTex <bool uvspace=true; string uiname="Texture Transform";>;
float4x4 tColor <string uiname="Color Transform";>;

struct VS_IN
{
	float4 pos : POSITION;
	float4 uv : TEXCOORD0;
	uint iv : SV_VertexID;
};

struct VS_OUT
{
    float4 pos: SV_POSITION;
    float4 uv: TEXCOORD0;
	float4 color : COLOR;
};

VS_OUT VS(VS_IN input)
{
    VS_OUT output = (VS_OUT)0;
    output.pos  = mul(input.pos,mul(tW,tVP));
    output.uv = mul(input.uv, tTex);
	output.color = color[input.iv];
    return output;
}

float4 PS(VS_OUT input): SV_Target
{
    //float4 col = tex0.Sample(s0,input.uv.xy) * cAmb;
	//col.a *= Alpha;
    return input.color;
}

technique10 Template
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




